#include <stdio.h>
#include <stdlib.h>

int main(void)
{
	double acum[102],qq[101],dist[101],gen[101];
	long hist[101];
	double m,g,y,wbin,q2;
        long k,n,ngen,ibin;

	FILE *fp1,*fp2;
	fp1 = fopen("plot.dat","w");
	fp2 = fopen("hist.dat","w");

	srand(12345679);

        m=90;
	g=2;
	for (k=0; k<=100; k++){
		qq[k]=m+(k-50.)/50.*5.*g;
		dist[k]=1./sqrt(
			((qq[k]*qq[k]-m*m)*(qq[k]*qq[k]-m*m)+m*m*g*g)
							);
		acum[k+1]=acum[k]+dist[k];
	}

	for (k=0; k<=100; k++){
		fprintf(fp1,"%f %f %f \n ",qq[k],dist[k],
		acum[k]/acum[101]*dist[50]);
	}

	for (k=0; k<=100; k++){hist[k]=0;}
	wbin=qq[1]-qq[0];

	ngen=100000;
	for (n=1; n<=ngen; n++){
		y=rand()/(double)RAND_MAX;
		gen[n]=qq[0];
		k=1;
		while (y>=acum[k]/acum[101]){
			gen[n]=qq[k-1];
			k++;
		}
		ibin=(gen[n]+wbin/2.-qq[0])/(qq[100]-qq[0])*100;
		hist[ibin]++;
	}
	for (k=1; k<= 99; k++){
		q2=(dist[k  ]/acum[101]*(double)ngen
		  + dist[k+1]/acum[101]*(double)ngen)/2.;
		fprintf(fp2,"%f %f %d \n",qq[k],q2,hist[k]);
	}

	fclose(fp1);
	fclose(fp2);
	return 0;
}
