#include <stdio.h>
#include <stdlib.h>

int main(void)
{
	double acum[102],x[101],dist[101],gen[101];
	long hist[101];
	double a,y,wbin;
        long k,n,ngen,ibin;

	FILE *fp1,*fp2;
	fp1 = fopen("plot.dat","w");
	fp2 = fopen("hist.dat","w");

	srand(12345679);

	a=0.9;
	for (k=0; k<=100; k++){
		x[k]=-1+2.*(double)k/100.;
		dist[k]=1./(1.-a*x[k]);
		acum[k+1]=acum[k]+dist[k];
	}

	for (k=0; k<=100; k++){
		fprintf(fp1,"%f %f %f \n ",x[k],dist[k],
		acum[k]/acum[101]*dist[50]);
	}

	for (k=0; k<=100; k++){hist[k]=0;}
	wbin=x[1]-x[0];

	ngen=100000;
	for (n=1; n<=ngen; n++){
		y=rand()/(double)RAND_MAX;
		gen[n]=x[0];
		k=1;
		while (y>=acum[k]/acum[101]){
			gen[n]=x[k];
			k++;
		}
		k--;
		ibin=(gen[n]+wbin/2.-x[0])/(x[100]-x[0])*100;
		hist[ibin]++;
	}
	for (k=0; k<=100; k++){
		fprintf(fp2,"%f %f %d \n",
                x[k],dist[k]/acum[101]*(double)ngen,hist[k]);
	}

	fclose(fp1);
	fclose(fp2);
	return 0;
}
