#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define nbin 1000
#define ngen 100000

int main(void)
{
	double lambda,a1,a2[nbin+1],pf[nbin+1],pk[nbin+1][nbin+1];
	double initx[ngen],genx[ngen],x,y,the,eta,xi,tempx,arg;
	long hist1[101];
	long hist2[101];
        int k,n,l,ok,i,nh;
  
	FILE *fp1;
	fp1 = fopen("plot.dat","w");

	srand(12345679);

	lambda=0.5;

	for (k=0;k<=100; k++){
		hist1[k]=0;
		hist2[k]=0;
	}

	for (k=0; k<=nbin; k++){
		for (l=0;l<=nbin;l++){
			pk[k][l]=0.;
		}
	}

	a1=1./6.;
	/*a1=1./12.;*/
	for (k=0; k<=nbin; k++){
		x=(double)k/(double)nbin;
		pf[k]=(1./2.*x*x-1./3.*x*x*x)/a1;
		/*pf[k]=(1./3.*x*x*x-1./4.*x*x*x*x)/a1;*/
		for (l=0;l<=k;l++){
			y=(double)l/(double)nbin;
			if(k+l==2*nbin){
				a2[l]  = 1;
				pk[k][l]= 0;
			}else{
				arg=y-1.;
				a2[l]  = 1.-exp(arg);
				arg=y-x;
				pk[k][l]=(1.-exp(arg))/a2[l];
			}
		}
	}

	for (n=1;n<=ngen;n++){
		eta=rand()/(double)RAND_MAX;
		k=0;
		while (eta>=pf[k]){
			initx[n]=(double)k/(double)nbin;
			k++;
		}
		k--;

		genx[n]=initx[n];
		ok=0;
		while (ok==0){
	 		eta=rand()/(double)RAND_MAX;
			the=lambda*pk[nbin][k]*a2[k];
			if (eta<the){
				i=k;
	 			xi=rand()/(double)RAND_MAX;
				while (xi>=pk[i][k]){
					tempx=(double)i/(double)nbin;
					genx[n]=tempx;
					i++;
				}
				k=i-1;
			}else{
				ok=1;
			}
		}
		nh=initx[n]*100.;
		hist1[nh]++;
		nh=genx[n]*100.;
		hist2[nh]++;
	}
	for (k=0;k<=100;k++){
		fprintf(fp1,"%d %d \n",hist1[k],hist2[k]);
	}

	fclose(fp1);
	return 0;
}
